global gPollRate, gTeslaIsHere
#your phone # below
property mobileNumber : "+15555555555"

tell application "IndigoServer"
	log "IN LOCATE"
	Growl("Home Security", "test")
	set value of variable "tesla_last_poll_time" to my readFile("/Users/tornado/scripts/lastTimePolledReadable.txt")
	set priorLocation to value of variable "tesla_current_location"
	#	set value of variable "tesla_prior_location" to priorLocation
	my setvariable("tesla_prior_location", priorLocation)
	set priorLocationX to value of variable "tesla_current_location_x"
	set priorLocationY to value of variable "tesla_current_location_y"
	set daylightVar to value of variable "isDaylight"
	set gPollRate to value of variable "tesla_pollrate_seconds"
	set garage_door_open to value of variable "isGarageDoorOpen"
	set TeslaIsHere to value of variable "tesla_is_here"
	#	set gTeslaIsHere to value of variable "tesla_is_here"
	if value of variable "tesla_is_here" is "true" then
		#if value of variable "tesla_is_here" is true then
		set gTeslaIsHere to true
	else
		set gTeslaIsHere to false
	end if
	#this converts the goofy text to a bool (below)
	log "daylight is:" & daylightVar
	if daylightVar is equal to "true" then
		#		log "daylightTIME!"
		set daylightVar to true
	end if
	
	set currentLocationTemp to do shell script "/usr/local/bin/node /Users/tornado/development/teslams-master/examples/teslamap.js -u tornado -p PASSWORD"
	
	-- Assign the response value to an Indigo variable.
	#	set value of variable "tesla_current_location" to currentLocation
	#	my setvariable("tesla_current_location", currentLocation)
	#	log "currentLocationTemp:" & currentLocationTemp
	# catch an annoying API issue below
	if currentLocationTemp as string is equal to "Error: undefined drive state returned from Tesla. Try again." then
		log "Can't wake tesla right now"
		return
	end if
	
	set thenums to my returnnumbersinstring(currentLocationTemp)
	set x2 to item 1 of thenums
	set y2 to "-" & item 2 of thenums
	#	log "gTeslaIsHere:" & gTeslaIsHere
	#	log "TeslaIsHere:" & TeslaIsHere
	if gTeslaIsHere is true then #only reduce decimal count when we're in the garage
		set x to my roundThis(x2, 3)
		set y to my roundThis(y2, 3)
	else
		set x to x2
		set y to y2
	end if
	set currentLocation to (x as string) & "," & (y as string)
	#log "GOT HERE!2"
	# POST ROUNDING DOWN TO 4 DECIMALS, WE SAVE THE CURRENT COMPLETE LOCATION
	my setvariable("tesla_current_location", currentLocation)
	#log "GOT HERE!3"
	#	set value of variable "tesla_current_location_x" to x
	my setvariable("tesla_current_location_x", x)
	my setvariable("tesla_current_location_y", y)
	#	set value of variable "tesla_current_location_y" to y
	
	set x_is_in_garage to false
	set y_is_in_garage to false
	set x_is_close_to_home to false
	set y_is_close_to_home to false
	#PLUG IN YOUR LOCATIONS BELOW
	set in_garage_x to 43.453202 * 10000
	set in_garage_y to -117.762255 * 10000
	set home_x to 43.455001 * 10000
	set home_y to -108.761657 * 10000
	set x1 to x
	set y1 to y
	set x to x * 10000
	set y to y * 10000
	set delta_x_garage to in_garage_x - x
	set delta_y_garage to in_garage_y - y
	if delta_x_garage < 0 then set delta_x_garage to delta_x_garage * -1
	if delta_y_garage < 0 then set delta_y_garage to delta_y_garage * -1
	if (delta_x_garage ≤ 1.4) then
		set x_is_in_garage to true
	end if
	if (delta_y_garage ≤ 20) then
		set y_is_in_garage to true
	end if
	
	
	set delta_x_home to home_x - x
	set delta_y_home to home_y - y
	if delta_x_home < 0 then set delta_x_home to delta_x_home * -1
	if delta_y_home < 0 then set delta_y_home to delta_y_home * -1
	if (delta_x_home ≤ 1.4) then
		set x_is_close_to_home to true
	end if
	if (delta_y_home ≤ 20) then
		set y_is_close_to_home to true
	end if
	
	#log "GOT HERE!4"
	set tesla_moving to false
	#########################################
	# CHECK IF WE'RE PARKED AND AT HOME OR AWAY!!!!	
	#########################################		
	#	log "gPollRate2 is:" & gPollRate
	if priorLocation is equal to currentLocation then
		#		say "tesla is parked"
		set value of variable "tesla_is_parked" to true
		if x_is_in_garage and y_is_in_garage and garage_door_open is equal to "false" then
			#if x_is_in_garage and y_is_in_garage then
			log "Tesla is parked in the garage."
			if gPollRate as string is not equal to "600" then
				log "Setting poll rate to 10 minutes."
				my setvariable("tesla_pollrate_seconds", 600)
				# CREATE THE .TXT files in your own folders
				do shell script "rm '/Users/tornado/scripts/pollRate.txt'"
				do shell script "echo '600' >> '/Users/tornado/scripts/pollRate.txt'"
				set gTeslaIsHere to true
				my setvariable("tesla_is_here", true)
			end if
		else
			log "Tesla is parked somewhere else."
			my setvariable("tesla_is_here", false)
			my setPollRateTo60()
		end if
	else
		#	say "tesla is moving" 
		set value of variable "tesla_is_parked" to false
		set tesla_moving to true
	end if
	#	log "GOT HERE33!"
	if (tesla_moving) then
		#		log "GOT HERE44!"
		#		say "tesla is moving" waiting until completion no
		do shell script "afplay '/Library/Application Support/Perceptive Automation/Indigo 6/IndigoWebServer/sounds/singlequietheartbeat.aif'"
		
		--	tell application "Safari"
		--	open location "http://maps.apple.com/?q=" & x & "," & y & "&sspn=0.002885,0.006427&sll=" & x & "," & y
		#log "PRE SEND!"
		# uncomment the lines below to send the location of the car to a nearby mac. Substitute in your own in place of jfmbp.local below		
#		tell application "Finder" of machine "eppc://tornado:password@jfmbp.local"
#			try
#				open location "http://maps.apple.com/?q=" & x1 & "," & y1
#			end try
#		end tell
		--	end tell
		#log "POST SEND!"
		#		my setPollRateTo60() #don't leave this in as the 25 sec change would get overridden here
		#		log "55"
		#if (true) then
		
		set home_inside_gate_x to 41.455572 * 10000
		set home_inside_gate_y to -117.762376 * 10000
		set upway_x to 41.455235 * 10000
		set upway_y to -117.762844 * 10000
		set horse_riding_area_x to 41.478275 * 10000
		set horse_riding_area_y to -117.788145 * 10000
		set end_of_driveway_x to 41.454037 * 10000
		set end_of_driveway_y to -117.762945 * 10000
		set top_of_141st_x to 41.452973 * 10000
		set top_of_141st_y to -117.768071 * 10000
		
		set priorLocationX to priorLocationX * 10000
		set priorLocationY to priorLocationY * 10000
		
		#calculate delta between car location and targets
		
		set delta_x_inside_gate to home_inside_gate_x - x
		set delta_y_inside_gate to home_inside_gate_y - y
		set delta_x_upway to upway_x - x
		set delta_y_upway to upway_y - y
		set delta_leaving_up_x to x - priorLocationX
		set delta_leaving_up_y to y - priorLocationY
		
		#get absolute values
		
		if delta_x_inside_gate < 0 then set delta_x_inside_gate to delta_x_inside_gate * -1
		if delta_y_inside_gate < 0 then set delta_y_inside_gate to delta_y_inside_gate * -1
		if delta_x_upway < 0 then set delta_x_upway to delta_x_upway * -1
		if delta_y_upway < 0 then set delta_y_upway to delta_y_upway * -1
		#	if delta_leaving_up_x < 0 then set delta_leaving_up_x to delta_leaving_up_x * -1
		#	if delta_leaving_up_y < 0 then set delta_leaving_up_y to delta_leaving_up_y * -1
		
		set leaving_up to false
		set x_is_close_to_upway to false
		set y_is_close_to_upway to false
		
		set within_up_way to false
		set horse_x to false
		set horse_y to false
		set x_inside_gate to false
		set y_inside_gate to false
		if (horse_riding_area_x > x) and (x > top_of_141st_x) then
			set horse_x to true
		end if
		if (horse_riding_area_y < y) and (y < top_of_141st_y) then
			set horse_y to true
		end if
		if (horse_x) and (horse_y) then
			set within_up_way to true
		end if
		
		
		if (delta_x_upway ≤ 137) then
			set x_is_close_to_upway to true
		end if
		if (delta_y_upway ≤ 3.8) then
			set y_is_close_to_upway to true
		end if
		if (delta_x_inside_gate ≤ 137) then
			set x_inside_gate to true
		end if
		if (delta_y_inside_gate ≤ 3.8) then
			set y_inside_gate to true
		end if
		
		log "daylight is:" & daylightVar
		log "gPollRate is:" & gPollRate
		#log "x is:" & x
		#log "y is:" & y
		#		log "horse_x is:" & horse_x
		#		log "horse_y is:" & horse_y
		#		log "delta_x_home:" & delta_x_home & " needs to be < 13700"
		#		log "delta_y_home:" & delta_y_home & " needs to be < 3.9"
		#		log "delta_x_inside_gate:" & delta_x_inside_gate & " needs to be < 13700"
		#		log "delta_y_inside_gate:" & delta_y_inside_gate & " needs to be < 3.9"
		#		log "x_inside_gate:" & x_inside_gate
		#		log "y_inside_gate:" & y_inside_gate
		log "x_up is close to driveway/home/upway:" & x_is_close_to_upway
		log "y_up is close to driveway/home/upway:" & y_is_close_to_upway
		#		log "delta_leaving_up_x:" & delta_leaving_up_x
		#		log "delta_leaving_up_y:" & delta_leaving_up_y
		log "within_up_way:" & within_up_way
		#		log "horse_riding_x:" & horse_riding_area_x & "< x:" & x & "< top_of_141st_x:" & top_of_141st_x
		#		log "horse_riding_y:" & horse_riding_area_y & "< y:" & y & "< top_of_141st_y:" & top_of_141st_y
		log "************x is close to home:" & x_is_close_to_home
		log "************y is close to home:" & y_is_close_to_home
		log " ###### delta_x_upway:" & delta_x_upway
		log " ###### delta_y_upway:" & delta_y_upway
		#		log "tesla_is_here:" & tesla_is_here
		log "garage_door_open:" & garage_door_open
		
		#########################################
		# CHECK IF WE'RE LEAVING THE neighborhood!!!!	
		#########################################	
		if (delta_leaving_up_x > 0) and (delta_leaving_up_y < 0) and (within_up_way) and (gPollRate is not equal to "60") then
			#we are getting larger (ie, moving away)
			#HOWEVER COMING INTO THE DRIVEWAY MAY ACTIVATE THIS!!!!
			say "Leaving up way."
			set leaving_up to true
			log "Leaving up way."
			my setPollRateTo60()
			log "leaving_up:" & leaving_up
			
			#########################################
			# CHECK IF WE'RE ENTERING THE neighborhood!!!!	
			#########################################			
		else if (delta_leaving_up_x < 0) and (delta_leaving_up_y > 0) and (within_up_way) and (gPollRate is not equal to "25") then
			set leaving_up to false
			say "On up way."
			log "Tesla is returning on up way. Increase to 25 second increments."
			do shell script "afplay '/Library/Application Support/Perceptive Automation/Indigo 6/IndigoWebServer/sounds/doublequietheartbeat.aif'"
			my setvariable("tesla_pollrate_seconds", 25)
			do shell script "rm '/Users/tornado/scripts/pollRate.txt'"
			do shell script "echo '25' >> '/Users/tornado/scripts/pollRate.txt'"
			log "leaving_up:" & leaving_up
		end if
		
		#########################################
		# CHECK IF WE'RE NEAR THE DRIVEWAY
		#########################################		
		if (x_is_close_to_upway and y_is_close_to_upway) then
			say "Near driveway!!"
			#speed up polling
			do shell script "afplay '/Library/Application Support/Perceptive Automation/Indigo 6/IndigoWebServer/sounds/triplequietheartbeat.aif'"
			my setvariable("tesla_pollrate_seconds", 10)
			do shell script "rm '/Users/tornado/scripts/pollRate.txt'"
			do shell script "echo '10' >> '/Users/tornado/scripts/pollRate.txt'"
			log "TESLA IS near the driveway"
		end if
		
		#########################################
		# CHECK IF WE'RE AT THE GATE!!!!!!!!!!!!!!
		#########################################		
		if (x_inside_gate and y_inside_gate) then
			say "At gate"
			if gTeslaIsHere is false then
				log "TESLA IS AT THE GATE."
				#				log "gTeslaIsHere:" & gTeslaIsHere
				log "#############################  TESLA IS HOME!"
				say "ARRIVING!"
				my setPollRateTo60()
				if garage_door_open is equal to "false" then
					log "Garage Door was closed. Opening it."
					#					say "GARAGE!"
					execute group "Toggle Garage Door after 1 second"
				end if
				if (daylightVar is not equal to true) then
					log "Lights were off - turning them on"
					say "LIGHTS!"
					execute group "deck Lights On For 10 Minutes"
					execute group "landscape Lights On For 10 Minutes"
					execute group "main_garage_ext Lights On For 10 Minutes"
				end if
				Growl("Home Security", "test")
				execute group "Flicker Toggle Den Lights When Tesla Returns"
			else
				log "TESLA IS AT THE GATE AND LEAVING"
				log "gTeslaIsHere:" & gTeslaIsHere
				my setPollRateTo60()
				say "Tesla is leaving. Close garage door."
				if garage_door_open is equal to "true" then
					log "Garage Door was open. Closing it."
					say "Garage Door was open. Closing it."
					execute group "Toggle Garage Door"
				end if
			end if
		end if				
	end if
end tell

on readFile(unixPath)
	return (do shell script "cat '" & unixPath & "'")
end readFile

on setvariable(theVariable, theValue)
	tell application "IndigoServer"
		if variable theVariable exists then
			#			set tempVar to value of variable theVariable
			#			log "tempvar = " & tempVar
			#			log "value = " & value of variable theVariable
			#only set it if the value is different
			if (value of variable theVariable) is not equal to theValue as string then
				log "Setting variable " & theVariable & " to " & theValue
				set value of variable theVariable to theValue
			end if
		else
			make new variable with properties {name:theVariable, value:theValue}
		end if
	end tell
end setvariable

on setPollRateTo60()
	if gPollRate is not equal to "60" then
		my setvariable("tesla_pollrate_seconds", 60)
		do shell script "rm '/Users/tornado/scripts/pollRate.txt'"
		do shell script "echo '60' >> '/Users/tornado/scripts/pollRate.txt'"
		set gTeslaIsHere to false
		my setvariable("tesla_is_here", false)
	end if
end setPollRateTo60

on returnnumbersinstring(inputString)
	set s to quoted form of inputString
	do shell script "sed s/[a-zA-Z\\']//g <<< " & s
	set dx to the result
	set numlist to {}
	repeat with i from 1 to count of words in dx
		set this_item to word i of dx
		try
			set this_item to this_item as number
			set the end of numlist to this_item
		end try
	end repeat
	return numlist
end returnnumbersinstring

on roundThis(n, numDecimals)
	set x to 10 ^ numDecimals
	(((n * x) + 0.5) div 1) / x
end roundThis

on SendSMS(message)
	tell application "Messages"
		activate
		if status is offline then
			log in of service "AIM"
		end if
		send message to buddy mobileNumber of service "AIM"
	end tell
end SendSMS

on convertFromSecondsToTime(totalSeconds)
	#set totalSeconds to endtime - starttime 
	
	set theHours to (totalSeconds div hours)
	set theRemainderSeconds to (totalSeconds mod hours)
	set theMinutes to (theRemainderSeconds div minutes)
	set theRemainderSeconds to (theRemainderSeconds mod minutes)
	
	set theTimeString to theHours & ":" & theMinutes & ":" & theRemainderSeconds as text
	return theTimeString
end convertFromSecondsToTime